Program Hanoiall;
{ Generates all solutios to the Towers of Hanoi problem
  in a text file solution.txt }
Uses Crt, Dataunit, Listunit;

Const fname = 'solution.txt';

Var theight,counter: integer;
    lasize: word;
    la: Listpoint;
    na: Nodepoint;
    f: Text;

Procedure AllSolutions(from,Too,Using :char; Height: integer;
                       var l: listpoint);
{ From, Too, Using are pole names (L,R,C). Height is the
  tower height. The top (smallest) disk has number 1.
  Returns list of all solutions. }

Var  np1,np2,np3,np: Nodepoint;
     l1,l2,l3: Listpoint;

Begin
   l := Newlist;
   If Height>1 then begin

      AllSolutions(From,Using,Too,Height-1,l1);  { Best way }
      AllSolutions(Using,Too,From,Height-1,l2);
      np1 := l1^.head;
      while np1<>nil do begin
         np2 := l2^.head;
         while np2<>nil do begin
            new(np);
            np^.el.s := np1^.el.s + ' ' + char(Height+48) + From + Too + ' ' + np2^.el.s;
            Inslast(np,l);
            np2 := np2^.succ;
         end{while};
         np1 := np1^.succ;
      end{while};

      AllSolutions(From,Too,Using,Height-1,l1);  { Worst way }
      AllSolutions(Too,From,Using,Height-1,l2);
      {AllSolutions(From,Too,Using,Height-1,l3);}
      np1 := l1^.head;
      while np1<>nil do begin
       np2 := l2^.head;
       while np2<>nil do begin
        np3 := l1^.head;
        while np3<>nil do begin
         new(np);
         np^.el.s := np1^.el.s + ' ' +
                     char(Height+48) + From + Using + ' ' +
                     np2^.el.s + ' ' +
                     char(Height+48) + Using + Too + ' ' +
                     np3^.el.s;
         Inslast(np,l);
         np3 := np3^.succ;
        end{while};
        np2 := np2^.succ;
       end{while};
       np1 := np1^.succ;
      end{while};

   end else begin  { Height = 1}
      new(np);
      np^.el.s := '1' + From + Too;
      Inslast(np,l);
      new(np);
      np^.el.s := '1' + From + Using + ' 1' + Using + Too;
      Inslast(np,l);
   end{if};
End;

Begin
   Assign(f,fname);
   Rewrite(f);
   ClrScr;
   TextColor(LightBlue);
   Theight := 0;
   While (Theight<1) or (Theight>3) do begin
     Write('Enter height of the tower (1-3): ');
     Readln(Theight);
   end;
   TextColor(Green);
   AllSolutions('L','R','C',Theight,la);
   lasize := Getsize(la);
   Counter := 0;
   Writeln(f,Theight:5,' (tower height)');
   Writeln(f,lasize:5 ,' (number of generated solutions)');
   while not Empty(la) do begin
      na := Remfirst(la);
      Writeln(na^.el.s);
      Inc(Counter);
      Writeln(f,Counter:5,' ',na^.el.s);
   end{while};
   Close(f);
   TextColor(Yellow);
   Writeln('Total number of solutions: ',lasize);
   Readln;
End.
